PROGRAM Vorticity

!This program calculates relative vorticity from zonal and meridional wind components

IMPLICIT NONE
CHARACTER*56 :: filename1 = 'UINTERIM_JAN1980.dat' !zonal wind data - input1
CHARACTER*56 :: filename2 = 'VINTERIM_JAN1980.dat' !meridional wind data - input2
CHARACTER*57 :: filename3 = 'VOINTERIM_JAN1980.dat' !vorticity data - output
REAL :: u2d(100,56) !zonal wind array
REAL :: v2d(100,56) !meridional wind array
REAL :: vo2d(98,54) !vorticity array
INTEGER :: iunit,iolen,nijo,K,N,irec,i,j,nlon,nlat
REAL :: a,dx,dy,inc,lambda,phi
REAL, allocatable, dimension(:) :: vec1
REAL, allocatable, dimension(:) :: vec2
lambda = -150.0 !western longitude
phi = -61.5 !southern latitude
inc = 1.5 !horizontal resolution
nlon = 100 !grid points in longitude
nlat = 56 !grid points in latitude
a=6.37*(10**6) ! Earth radius

allocate(vec1(1))
allocate(vec2(1))
vec1 = [(phi + (j-1) * inc, j=1,nlat)]  
vec2 = [(lambda + (i-1) * inc, i=1,nlon)]

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

nijo=nlon*nlat
irec=1
iunit=1
INQUIRE(IOLENGTH=iolen) iolen 
OPEN(iunit,FILE=filename1,FORM='unformatted',ACCESS='direct',RECL=nijo*iolen)
READ(iunit,REC=irec) u2d
CLOSE(iunit)

iunit=2
INQUIRE(IOLENGTH=iolen) iolen 
OPEN(iunit,FILE=filename2,FORM='unformatted',ACCESS='direct',RECL=nijo*iolen)
READ(iunit,REC=irec) v2d
CLOSE(iunit)

i=1
j=1
DO N=2,55
  DO K=2,99  
   
      dx=a*((cos(vec1(N)*3.1416/180.0))*((vec2(K+1)-vec2(K-1))*3.1416/180.0)) 
      dy=a*((vec1(N+1)-vec1(N-1))*3.1416/180.0)
    
      vo2d(i,j) = ((v2d(K+1,N)-v2d(K-1,N))/(dx)) - ((u2d(K,N+1)-u2d(K,N-1))/(dy)) + ((u2d(K,N)*tan(vec1(N)*3.1416/180.0))/a)

     i=i+1
  END DO
  i=1
  j=j+1
END DO


iunit=3
OPEN(iunit,FILE=filename3,FORM='unformatted',ACCESS='direct',RECL=nijo*iolen)
WRITE(iunit,REC=irec) vo2d
CLOSE(iunit)


END PROGRAM Vorticity
